/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2002, 2006 All Rights Reserved.
 * (C) Copyright Webify Solutions, Inc. 2002, 2006 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.plm.context.extractor;

import com.ibm.websphere.fabric.da.PendingRequest;
import com.ibm.websphere.fabric.da.context.Context;
import com.ibm.websphere.fabric.da.plugin.ContextExtractor;
import com.ibm.websphere.fabric.da.plugin.UnexpectedContentException;
import com.ibm.websphere.fabric.da.types.TypedValue;
import commonj.sdo.DataObject;
import commonj.sdo.Sequence;

/**
 * 
 * @author ravikumarv@in.ibm.com
 *
 */
public class SupplierContextExtractorImpl implements ContextExtractor, IFabricConstant {
	
	
	/**
	 * Default constructor.
	 */
	public SupplierContextExtractorImpl() {
		super();
	}

		/* (non-Javadoc)
	 * @see com.ibm.websphere.fabric.da.plugin.ContextExtractor#extractContext(PendingRequest arg0) 
	 */
	public Context extractContext(PendingRequest req)
			throws UnexpectedContentException {
		Context context = req.getContext();
		
		Sequence sequence = (Sequence) req.getFirstBodyElement().get(0);
		
		DataObject requestDataObject = (DataObject) sequence.getValue(0);
	
		//System.out.println("requestDataObject: "+requestDataObject);
		
		String supplier = null;
		try {
		supplier = requestDataObject.get("PlmContainer/Activity.0/Supplying_organization").toString();
		
		 } catch(Exception ex) {
			ex.printStackTrace();
			//System.out.println("Inside catch......");
			//supplier = requestDataObject.get("PLM_container/Activity.0/Supplying_organization").toString();
		}
		if(supplier != null ) {
				supplier = supplier.substring(1, supplier.length()-1);
				
		}
		 
		//System.out.println("supplier: "+supplier);
		//supplier = "Jay";
		
		//System.out.println("Inside Context Extractor code.....................");
		
		if (supplier != null) {
			TypedValue assertionValue = new TypedValue(supplier);
			context.setSelectionProperty(SUPPLIER_TYPE_ASSERTION,
					assertionValue);
		} else {
			/*log.error("costValue"+costValue);
			log.error("costName"+costName);*/
		}

		TypedValue governanceFabricProjectValue = new TypedValue(
				FABRIC_GOVERNANCE);

		context.setSelectionProperty(FABRIC_GOVERNANCE_VALUE,
				governanceFabricProjectValue);
		
		return context;}

}